#ifndef IPROFILE_H
#define IPROFILE_H

#include	<windows.h>
#include	<string>

#include	<io_exception.h>

class IProfile {
public:
	virtual BOOL WriteProfileString(LPCTSTR section,LPCTSTR entry,const char *value) = 0;
	virtual BOOL WriteProfileInt(LPCTSTR section,LPCTSTR entry,int value) = 0;
	virtual std::string GetProfileString(LPCTSTR section,LPCTSTR entry,char *defaultValue) = 0;
	virtual int GetProfileInt(LPCTSTR section,LPCTSTR entry,int defaultValue) = 0;
};

#endif
