#ifndef REGISTORYPROFILE_H
#define REGISTORYPROFILE_H

#include	"IProfile.h"

class RegistoryProfile : public IProfile {
	char *registoryKey;	// WXgL[
	char *appName;	// AvP[V
	
	HKEY hKey;
public:
	BOOL WriteProfileString(LPCTSTR section,LPCTSTR entry,const char *value);
	BOOL WriteProfileInt(LPCTSTR section,LPCTSTR entry,int value);
	std::string GetProfileString(LPCTSTR section,LPCTSTR entry,char *defaultValue);
	int GetProfileInt(LPCTSTR section,LPCTSTR entry,int defaultValue);
	
	void SetRegistryKey(char *key){
		registoryKey = key;
	}
	
	void SetApplicationName(char *name){
		appName = name;
	}
};

#endif
