#ifndef OP19FORM_H
#define OP19FORM_H

#include "ChildDialog.h"
#include "tstring.h"
#include "TwrCombobox.h"

#define OP19_STABLE_BOOKMARK "\\Opera Software\\Opera Stable\\Bookmarks"
#define OP19_NEXT_BOOKMARK "\\Opera Software\\Opera Next\\Bookmarks"
#define OP19_DEVELOPER_BOOKMARK "\\Opera Software\\Opera Developer\\Bookmarks"

class COp19Form : public ChildDialog {
private:
	TwrControl *editOp19_1;
	TwrControl *editOp19_2;
	TwrControl *chkOp19_1;
	TwrControl *chkOp19_2;
	TwrControl *ignoreToolbarOp19_1;
	TwrControl *ignoreToolbarOp19_2;
	TwrControl *chkOp19Trash_1;
	TwrControl *chkOp19Trash_2;
	TwrControl *inFolderOp19_1;
	TwrControl *inFolderOp19_2;
	TwrControl *chkOp29SpeedDial;
	TwrControl *groupOp19_1;
	TwrControl *groupOp19_2;
	TwrControl *refOp19_1;
	TwrControl *refOp19_2;
	TwrControl *findOp19_1;
	TwrControl *findOp19_2;
	TwrControl *ignoreUnsort_1;
	TwrControl *ignoreUnsort_2;

	tstring GetBookmark(TCHAR *path);

	void OnBnClickedButtonsearchOp19_1();
	void OnBnClickedButtonsearchOp19_2();
	void OnBnClickedRefOp19_1();
	void OnBnClickedRefOp19_2();
	bool confirm(HWND hWnd,tstring &bookmark,int pos, int type);

protected:
	INT_PTR OnInitDialog();
	void OnLoad(void);
	INT_PTR OnCommand(WPARAM wParam);

public:
	// ubN}[Ñt@C1
	tstring m_Op19BM1;
	// ubN}[Ñt@C2
	tstring m_Op19BM2;
	BOOL m_chkOp19_1;
	BOOL m_chkOp19_2;
	// ubN}[No[𖳎邩ǂ1
	BOOL m_chkIgnoreToolbar1;
	// ubN}[No[𖳎邩ǂ2
	BOOL m_chkIgnoreToolbar2;
	// Opera 30̃S~𖳎邩ǂ(1)
	BOOL m_Opera19Trash1;
	// Opera 30̃S~𖳎邩ǂ(2)
	BOOL m_Opera19Trash2;
	// tH_ɃtH_邩ǂ1
	BOOL m_chkInFolder1;
	// tH_ɃtH_邩ǂ2
	BOOL m_chkInFolder2;
	// Unsorted bookmarks𖳎邩ǂ1
	BOOL m_chkNoUnsorted1;
	// Unsorted bookmarks𖳎邩ǂ2
	BOOL m_chkNoUnsorted2;
	// Opera 29ȍ~̃Xs[h_C𑼂̃ubN}[Nɏo͂邩
	BOOL m_chkOp29SpeedDial;

	COp19Form(HWND parent, int resource);
	~COp19Form();
	void UpdateData(bool toObj);
	void setSettingEnable(void);

	void searchOp19_1(HWND hWnd);
	void searchOp19_2(HWND hWnd);

};

#endif // OP19FORM_H

