#ifndef VIFORM_H
#define VIFORM_H

#include "ChildDialog.h"
#include "tstring.h"
#include "TwrCombobox.h"
#include "TJson.h"

#define VI_BOOKMARK_OLD_FULL "\\Vivaldi\\User Data\\Default\\Bookmarks"
#define VI_CONFIG_BASE "\\Vivaldi\\User Data"
#define VI_CONFIG_FILE "\\Local State"

class CViForm : public ChildDialog {
private:
	TwrControl *editVi_1;
	TwrControl *editVi_2;
	TwrControl *chkVi_1;
	TwrControl *chkVi_2;
	TwrControl *chkViTrash_1;
	TwrControl *chkViTrash_2;
	TwrControl *inFolderVi_1;
	TwrControl *inFolderVi_2;
	TwrControl *groupVi_1;
	TwrControl *groupVi_2;
	TwrControl *refVi_1;
	TwrControl *refVi_2;
	TwrControl *findVi_1;
	TwrControl *findVi_2;
	//TwrCombobox *layoutVi1;
	//TwrCombobox *layoutVi2;
	//TwrControl *layoutTextVi1;
	//TwrControl *layoutTextVi2;

	tstring GetBookmark(TCHAR *path);
	tstring GetBookmark2(HWND hWnd, int pos, tstring exclude);
	tstring searchProfile(
		HWND hWnd,
		TJson *jsonObj,
		TCHAR *profiles,
		int pos,
		tstring base,
		tstring exclude);

	void OnBnClickedButtonsearchVi_1();
	void OnBnClickedButtonsearchVi_2();
	void OnBnClickedRefVi_1();
	void OnBnClickedRefVi_2();
	bool confirm(HWND hWnd,tstring &bookmark,int pos, int type);

protected:
	INT_PTR OnInitDialog();
	void OnLoad(void);
	INT_PTR OnCommand(WPARAM wParam);

public:
	// ubN}[Ñt@C1
	tstring m_ViBM1;
	// ubN}[Ñt@C2
	tstring m_ViBM2;
	BOOL m_chkVi_1;
	BOOL m_chkVi_2;
	// VivaldĩS~𖳎邩ǂ(1)
	BOOL m_ViTrash1;
	// VivaldĩS~𖳎邩ǂ(2)
	BOOL m_ViTrash2;
	// t@C1̃CAEg
	int m_LayoutVi1;
	// t@C2̃CAEg
	int m_LayoutVi2;

	CViForm(HWND parent, int resource);
	~CViForm();
	void UpdateData(bool toObj);
	void setSettingEnable(void);

	void searchVi_1(HWND hWnd);
	void searchVi_2(HWND hWnd);

};

#endif // VIFORM_H

