#include	<stdlib.h>
#include	<new>
#include	<memory>

#include	<stdio.h>
#include	<string.h>
#include	<time.h>
#include	<mbstring.h>

#include	"encutil2.h"
#include	"Bookmark.h"
#include	"ViBookmark.h"

/**
 * RXgN^
 */
ViBookmark::ViBookmark()
{
	_init();
}

/**
 * Rs[RXgN^
 *
 * @param src Rs[̃IuWFNg
 */
ViBookmark::ViBookmark(const ViBookmark &src)
{
	_init();
	_copy(src);
}

/**
 * fXgN^
 */
ViBookmark::~ViBookmark()
{
	_reset();
}

/**
 *	CX^X̓eɏlB<br>
 *	RXgN^p
 *
 */
void ViBookmark::_init(void)
{
	m_id = NULL;
	m_isSpeedDial = false;
	m_Thumbnail = NULL;
	m_isBookmarkBar = false;
}

/**
 * CX^X̓eĐݒ肷B(Jt)
 */
void ViBookmark::_reset(void)
{
	if (m_id != NULL) {
		delete[]m_id;
		m_id = NULL;
	}
	if (m_Thumbnail != NULL) {
		delete[]m_Thumbnail;
	}
	_init();
}

/**
 * CX^X̃Rs[
 *
 * @param src ʌBookmarkNX̃CX^X̎Q
 */
void ViBookmark::_copy(const ViBookmark &src)
{
	setSpeedDial(src.getSpeedDial());
	setThumbnail(src.getThumbnail());
	setBookmarkBar(src.getBookmarkBar());
}

/**
 * CX^XŜ̓eB
 */
void ViBookmark::reset(void)
{
	_reset();
}

/**
 * CX^X̃Rs[
 *
 * @param src ʌBookmarkNX̃CX^X̎Q
 */
void ViBookmark::copy(const ViBookmark &src)
{
	_copy(src);
}

/**
 * =ZqɂCX^X̃Rs[
 *
 * @param src ʌBookmarkNX̃CX^X̎Q
 * @return g̎Q
 */
ViBookmark & ViBookmark::operator = (const ViBookmark &src)
{
	reset();
	copy(src);
	setID(src.getID());

	return *this;
}

/**
 * ubN}[NRs[(ubN}[Nʗp)
 *
 * @param src ʌBookmarkNX̃CX^Xւ̃|C^
 * @return 0Œ
 */
void ViBookmark::copyWithoutId(ViBookmark *src)
{
	_copy(*src);
}

/**
* ubN}[N̎ʏRs[
*
* @param src ʌBookmarkNX̃CX^Xւ̃|C^
* @return 0Œ
*/
int ViBookmark::copyBookmarkIdentifier(ViBookmark *src)
{
	if (src->getID() != NULL) {
		setID(src->getID());
	}

	return 0;
}


/**
 * IDݒ肷B
 *
 * @param item ݒ肷ID
 * @return ݒ肵IDւ̃|C^
 */
char *ViBookmark::setID(const char *item)
{
	char *p;
	int len;
	
	if (m_id != NULL){
		delete []m_id;
		m_id = NULL;
	}

	if (item == NULL){
		return NULL;
	}

	len = strlen(item) + 1;
	
	try{
		p = new char[len];
		if (p == NULL){
			return NULL;
		}
		strcpy(p,item);
		m_id = p;
	}catch(...){
		return NULL;
	}
	return p;
}

