#ifndef FXFORM_H
#define FXFORM_H

#include "ChildDialog.h"
#include "tstring.h"

class CFxForm : public ChildDialog {
private:
	TwrControl *editFx1;
	TwrControl *editFx2;
	TwrControl *chkFx1;
	TwrControl *chkFx2;
	TwrControl *ignoreToolbarFx1;
	TwrControl *ignoreToolbarFx2;
	TwrControl *ignorePlaces;
	TwrControl *optimizeFx1;	// IDC_CHECK_FX_OPTIMIZE1
	TwrControl *optimizeFx2;	// IDC_CHECK_FX_OPTIMIZE2
	TwrControl *groupFx1;
	TwrControl *groupFx2;
	TwrControl *refFx1;
	TwrControl *refFx2;
	TwrControl *findFx1;
	TwrControl *findFx2;

	tstring GetMozFireBookmark(HWND hWnd,TCHAR *appProfile,int type,int pos);
	tstring getMozFireProfile(
		HWND hWnd,
		const TCHAR *profileDir,
		const TCHAR *appProfile,
		const TCHAR *profiles,
		const TCHAR *section,
		int type,
		int pos);

	void OnBnClickedButtonsearchfx31();
	void OnBnClickedButtonsearchfx32();
	void OnBnClickedReffx1();
	void OnBnClickedReffx2();

protected:
	INT_PTR OnInitDialog();
	void OnLoad(void);
	INT_PTR OnCommand(WPARAM wParam);

public:
	// ubN}[Ñt@C1
	tstring m_FxBM1;
	// ubN}[Ñt@C2
	tstring m_FxBM2;
	BOOL m_chkFx1;
	BOOL m_chkFx2;
	BOOL m_chkIEfav1;
	BOOL m_chkIEfav2;
	// ubN}[Nc[o[𖳎邩ǂ1
	BOOL m_chkIgnoreToolbar1;
	// ubN}[Nc[o[𖳎邩ǂ2
	BOOL m_chkIgnoreToolbar2;
	// œK邩ǂ1
	BOOL m_chkOptimize1;
	// œK邩ǂ2
	BOOL m_chkOptimize2;
	// X}[gubN}[N𑼂̃uEŨubN}[Nɏo͂邩ǂ
	BOOL m_placesPut;

	CFxForm(HWND parent, int resource);
	~CFxForm();
	void UpdateData(bool toObj);
	void setSettingEnable(void);

	void searchFx1(HWND hWnd);
	void searchFx2(HWND hWnd);

};

#endif // SFFORM_H

